#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <queue>
#include <bitset>

using namespace std;

#define NMAX 1505

// In order for the solution to be correct, CM must be a large(r) odd number -- but that causes TLE.
#define CM 13

int drow[4] = { -1, 0, +1, 0};
int dcol[4] = { 0, +1, 0, -1};
char A[NMAX][NMAX];

int M, N, i, j, is, js, out;
bitset<CM * NMAX> visited[CM * NMAX];
queue<pair<int, int> > q;

void Expand(int istart, int jstart) {
	int i, j, k;
	pair<int, int> p, pnext;

	pnext.first = istart;
	pnext.second = jstart;
	q.push(pnext);

	visited[istart].set(jstart, true);
	
	while (q.size() > 0) {
		p = q.front();
		q.pop();
		
		if (p.first == 0 || p.first == CM * M - 1 || p.second == 0 || p.second == CM * N - 1) {
			out = 1;
			break;
		}
		
		for (k = 0; k < 4; k++) {
			pnext.first = p.first + drow[k];
			pnext.second = p.second + dcol[k];
			i = pnext.first % M;
			j = pnext.second % N;

			if (pnext.first >= 0 && pnext.first < CM * M && pnext.second >= 0 && pnext.second < CM * N &&
				!visited[pnext.first][pnext.second] && A[i][j] != '#') {
				q.push(pnext);
				visited[pnext.first].set(pnext.second, true);
			}
		}
	}
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &M, &N);
	for (i = 0; i < M; i++) {
		scanf("%s", &A[i][0]);
	}
	
	for (i = (CM / 2) * M; i < (CM / 2 + 1) * M; i++)
		for (j = (CM / 2); j < (CM / 2 + 1) * N; j++)
			if (A[i % M][j % N] == 'S') {
				is = i;
				js = j;
			}

	out = 0;
	Expand(is, js);
	
	if (out)
		printf("Yes\n");
	else
		printf("No\n");

	return 0;
}
