// O(N*sqrt(N)) -- TLE (the time complexity is not good enough).

#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define NMAX 250001
#define KMAX 500

vector<pair<int, long long> > gripper;
int m[NMAX], p[NMAX], sel[NMAX];
long long r[NMAX], dist[NMAX];
vector<pair<long long, int> > dsort;
vector<pair<int, int> > cgroup;
long long gdmax[KMAX];
queue<int> gelems[KMAX];
int P, N, i, j, g, gmax;
long long R, x, y, u, v;

int main() {
	//freopen("198E.txt", "r", stdin);
	scanf("%I64d %I64d %d %I64d %d", &x, &y, &P, &R, &N);
	R *= R;
	gripper.push_back(make_pair(P, R));
	for (i = 0; i < N; i++) {
		scanf("%I64d %I64d %d %d %I64d\n", &u, &v, &m[i], &p[i], &r[i]);
		r[i] *= r[i];
		dist[i] = (u - x) * (u - x) + (v - y) * (v - y);
		dsort.push_back(make_pair(dist[i], i));
	}

	sort(dsort.begin(), dsort.end());
	memset(gdmax, 0, sizeof(gdmax));
	
	for (i = 0; i < N; i++) {
		long long d = dsort[i].first;
		int idx = dsort[i].second;
		g = i / KMAX;
		gdmax[g] = d;
		cgroup.push_back(make_pair(m[idx], idx));
		if (i == N - 1 || ((i + 1) % KMAX) == 0) {
			sort(cgroup.begin(), cgroup.end());
			for (j = 0; j < cgroup.size(); j++)
				gelems[g].push(cgroup[j].second);
		}
	}

	gmax = (N - 1) / KMAX;
	memset(sel, 0, sizeof(sel));
	for (i = 0; i < gripper.size(); i++) {
		P = gripper[i].first;
		R = gripper[i].second;
		//fprintf(stderr, "%d %I64d\n", P, R);

		for (g = 0; g <= gmax; g++)
			if (gdmax[g] <= R) {
				while (1) {
					if (gelems[g].size() == 0)
						break;
					int idx = gelems[g].front();
					if (sel[idx]) {
						gelems[g].pop();
						continue;
					}
					if (m[idx] <= P) {
						sel[idx] = 1;
						gripper.push_back(make_pair(p[idx], r[idx]));
						gelems[g].pop();
					} else
						break;
				}
			} else {
				for (j = g * KMAX; j < (g + 1) * KMAX && j < N; j++) {
					int idx = dsort[j].second;
					if (dist[idx] > R)
						break;
					if (!sel[idx] && m[idx] <= P) {
						sel[idx] = 1;
						gripper.push_back(make_pair(p[idx], r[idx]));
					}
				}
				break;
			}
	}
	
	printf("%d\n", gripper.size() - 1);
	return 0;
}
