#include <stdio.h>

#define NMAX 1000100

long long plus[NMAX];
int a[NMAX], vleft[NMAX], pleft[NMAX], vright[NMAX], pright[NMAX];
int N, M, i, j, k, nleft, nright;

void compute(int li, int ls) {
	if (li > ls)
		return;
	if (li == ls) {
		plus[1] += a[li];
		plus[2] -= a[li];
		return;
	}
	
	int mid = (li + ls) / 2;
	compute(li, mid);
	compute(mid + 1, ls);

	//fprintf(stderr, "li=%d ls=%d mid=%d\n", li, ls, mid);
	
	vleft[1] = a[mid];
	pleft[1] = mid;
	nleft = 1;
	for (i = mid - 1; i >= li; i--)
		if (a[i] < vleft[nleft]) {
			nleft++;
			vleft[nleft] = a[i];
			pleft[nleft] = i;
		}
		
	nleft++;
	vleft[nleft] = -1;
	pleft[nleft] = li - 1;
	
	vright[1] = a[mid + 1];
	pright[1] = mid + 1;
	nright = 1;
	for (i = mid + 2; i <= ls; i++) {
		if (a[i] < vright[nright]) {
			nright++;
			vright[nright] = a[i];
			pright[nright] = i;
		}
	}
	
	nright++;
	vright[nright] = -1;
	pright[nright] = ls + 1;
	
	i = j = 1;
	while (i < nleft || j < nright) {
		//fprintf(stderr, "i=%d/%d vi=%d pi=%d | j=%d/%d vj=%d pj=%d\n", i, nleft, vleft[i], pleft[i], j, nright, vright[j], pright[j]);
		if (vleft[i] <= vright[j]) {
			for (k = pright[j]; k < pright[j + 1]; k++) {
				plus[k - (mid - 1)] += vright[j];
				plus[k - pleft[i] + 1] -= vright[j];
			}
			j++;
		} else {
			for (k = pleft[i]; k > pleft[i + 1]; k--) {
				plus[mid + 1 - k + 1] += vleft[i];
				plus[pright[j] - k + 1] -= vleft[i];
			}
			i++;
		}
	}
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		scanf("%d", &a[i]);
	}
	
	compute(1, N);

	for (i = 2; i <= N; i++)
		plus[i] += plus[i - 1];
	
	/*
	for (i = 1; i <= N; i++) {
		printf("i=%d: sum=%I64d\n", i, plus[i]);
	}
	*/
	
	scanf("%d", &M);
	while (M--) {
		scanf("%d", &i);
		printf("%.9lf\n", (double) (plus[i]) / (double) (N - i + 1));
	}
	
	return 0;
}
