#include <stdio.h>
#include <algorithm>
#include <set>

using namespace std;

#define NMAX 100100

int pa[NMAX], pb[NMAX];
int m1[NMAX], m2[NMAX];
int extmax1[NMAX], extmax2[NMAX];
set<pair<int, int> > final_seg;
int i, j, N, x;

int fastSolution() {
	// Stage 1.
	for (i = 0; i < N; i++) {
		m1[i] = N;
		extmax1[i] = 0;
	}
	
	for (i = 1; i <= N; i++)
		if (pb[i] >= pa[i]) {
			int itzero = pb[i] - pa[i];
			m1[itzero] = 0;
			extmax1[itzero] = max(extmax1[itzero], itzero);
						
			int itcomeback = pb[i];
			if (itcomeback < N) {
				int vmin = pb[i] - pa[i] + 1;
				final_seg.insert(make_pair(vmin, itcomeback));
			}
		} else {
			int itzero = pb[i] + N - pa[i];
			m1[itzero] = 0;
			extmax1[itzero] = max(extmax1[itzero], N - pa[i]);
		}
	
	i = N - 1;
	while (i >= 0) {
		if (m1[i] == 0) {
			if (i - extmax1[i] < 0)
				return 1;
			for (j = 1; j <= extmax1[i]; j++) {
				if (m1[i - j] == 0) {
					final_seg.insert(make_pair(i - (N - 1), i - extmax1[i]));
					break;
				}
				m1[i - j] = min(m1[i - j], j);
			}
			i -= j;
		} else {
			while (1) {
				if (final_seg.size() == 0)
					break;
				pair<int, int> p = *(final_seg.begin());
				if (p.second > i) {
					//fprintf(stderr, "S1-size1=%d\n", final_seg.size());
					final_seg.erase(p);
					//fprintf(stderr, "S1-size2=%d\n", final_seg.size());
				} else {
					m1[i] = min(m1[i], p.first + N - 1 - i);
					break;
				}
			}
			i--;
		}
	}

	//for (i = 0; i <= N - 1; i++)
	//	fprintf(stderr, "i=%d: m1[i]=%d\n", i, m1[i]);
	
	// Stage 2.
	for (i = 0; i < N; i++) {
		m2[i] = N;
		extmax2[i] = 0;
	}
	
	final_seg.clear();
	for (i = 1; i <= N; i++)
		if (pb[i] < pa[i]) {
			int itzero = pb[i] + N - pa[i];
			m2[itzero] = 0;
			extmax2[itzero] = max(extmax2[itzero], N - 1 - itzero);
			
			int itend = pb[i] - 1;
			final_seg.insert(make_pair(pa[i] - pb[i], itend));
		} else {
			int itzero = pb[i] - pa[i];
			m2[itzero] = 0;
			extmax2[itzero] = max(extmax2[itzero], pa[i] - 1);
		}
	
	i = 0;
	while (i < N) {
		if (m2[i] == 0) {
			if (i + extmax2[i] >= N)
				return 1;
			for (j = 1; j <= extmax2[i]; j++) {
				if (m2[i + j] == 0) {
					final_seg.insert(make_pair(-i, i + extmax2[i]));
					break;
				}
				m2[i + j] = min(m2[i + j], j);
			}
			i += j;
		} else {
			while (1) {
				if (final_seg.size() == 0)
					break;
				pair<int, int> p = *(final_seg.begin());
				if (p.second < i) {
					//fprintf(stderr, "S2-size1=%d\n", final_seg.size());
					final_seg.erase(p);
					//fprintf(stderr, "S2-size2=%d\n", final_seg.size());
				} else {
					m2[i] = min(m2[i], p.first + i);
					break;
				}
			}
			i++;
		}
	}

	//for (i = 0; i <= N - 1; i++)
	//	fprintf(stderr, "i=%d: m2[i]=%d\n", i, m2[i]);
	
	//for (i = 0; i <= N - 1; i++)
	//	printf("i=%d, m1[i]=%d, m2[i]=%d, ans=%d\n", i, m1[i], m2[i], min(m1[i], m2[i]));

	for (i = 0; i < N; i++)
		printf("%d\n", min(m1[i], m2[i]));
	
	return 0;
}

int slowSolution() {
	for (i = 0; i < N; i++) {
		int dmin = N, minPair = -1;
		for (j = 1; j <= N; j++) {
			int d = abs(pa[j] - pb[j]);
			if (d < dmin) {
				dmin = d;
				minPair = j;
			}
			
			pb[j]--;
			if (pb[j] == 0)
				pb[j] = N;
		}
		printf("%d\n", dmin);
	}
	return 0;
}

int main() {
	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		scanf("%d", &x);
		pa[x] = i;
	}

	for (i = 1; i <= N; i++) {
		scanf("%d", &x);
		pb[x] = i;
	}

	return fastSolution();	
}
