#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MOD 1000000007

int w, h, i, j, k, rx1, ry1, rx2, ry2, rx3, ry3, npar;
long long np[4], total;
int result;

int gcd(int a, int b) {
	if (a % b == 0)
		return b;
	return gcd(b, a % b);
}

void fastSolution() {
	// Calculeaza nr de triunghiuri de arie >= 0 si coordonate diferite ale varfurilor.
	memset(np, 0, sizeof(np));
	np[0] = (w / 2 + 1) * (h / 2 + 1);
	np[1] = (w - w / 2) * (h / 2 + 1);
	np[2] = (w / 2 + 1) * (h - h / 2);
	np[3] = (w - w / 2) * (h - h / 2);

	total = 0;
	for (i = 0; i < 4; i++)
		for (j = i; j < 4; j++)
			for (k = j; k < 4; k++) {
				rx1 = i & 1, ry1 = (i >> 1) & 1;
				rx2 = j & 1, ry2 = (j >> 1) & 1;
				rx3 = k & 1, ry3 = (k >> 1) & 1;

				npar = 0;

				if (!rx1 || (ry2 == ry3)) npar++;
				if (!rx2 || (ry3 == ry1)) npar++;
				if (!rx3 || (ry1 == ry2)) npar++;

				if (npar == 1 || npar == 3) {
					if (i == j && j == k) {
						long long a = np[i], b = np[j] - 1, c = np[k] - 2;
						if (a % 2 == 0)
							a /= 2;
						else if (b % 2 == 0)
							b /= 2;
						else
							c /= 2;

						if (a % 3 == 0)
							a /= 3;
						else if (b % 3 == 0)
							b /= 3;
						else
							c /= 3;
						
						a = (a * b) % MOD;
						a = (a * c) % MOD;
						
						total = (total + a) % MOD;
					} else if (i == j) {
						long long a = np[i], b = np[j] - 1, c = np[k];
						if (a % 2 == 0)
							a /= 2;
						else if (b % 2 == 0)
							b /= 2;
						else
							c /= 2;

						a = (a * b) % MOD;
						a = (a * c) % MOD;
						
						total = (total + a) % MOD;
					} else if (j == k) {
						long long a = np[i], b = np[j], c = np[k] - 1;
						if (a % 2 == 0)
							a /= 2;
						else if (b % 2 == 0)
							b /= 2;
						else
							c /= 2;

						a = (a * b) % MOD;
						a = (a * c) % MOD;
						
						total = (total + a) % MOD;
					} else {
						long long a = np[i], b = np[j], c = np[k];
						a = (a * b) % MOD;
						a = (a * c) % MOD;						
						total = (total + a) % MOD;
					}
				}
			}
			
	// Scade nr de triunghiuri de arie exact 0 si coordonate diferite ale varfurilor.
	for (int dx = 0; dx <= w; dx++) {
		for (int dy = 1; dy <= h; dy++) {
			int d = gcd(abs(dx), dy);
			long long a = d - 1;
			long long b = w + 1 - dx;
			long long c = h + 1 - dy;
			
			a = (a * b) % MOD;
			a = (a * c) % MOD;
			if (dx > 0)
				a = (a * 2) % MOD;

			total = (total - a + MOD) % MOD;
		}
	
		if (dx >= 2) {
			long long a = dx - 1;
			long long b = w + 1 - dx;
			long long c = h + 1;
			a = (a * b) % MOD;
			a = (a * c) % MOD;
			total = (total - a + MOD) % MOD;
		}
	}

	total = (total * 6) % MOD;
	printf("%d\n", result = total);
}

void slowSolution() {
	int xa, ya, xb, yb, xc, yc;
	result = 0;

	for (xa = 0; xa <= w; xa++)
		for (ya = 0; ya <= h; ya++)
			for (xb = 0; xb <= w; xb++)
				for (yb = 0; yb <= h; yb++)
					for (xc = 0; xc <= w; xc++)
						for (yc = 0; yc <= h; yc++) {
							int area = xa * yb - xa * yc + xb * yc - xb * ya + xc * ya - xc * yb;
							if (area != 0 && area % 2 == 0)
								result = (result + 1) % MOD;
						}

	printf("%d\n", result);
}

int main() {
	scanf("%d %d", &w, &h);
	fastSolution();
	//slowSolution();

	return 0;
}
