#include <stdio.h>
#include <map>
#include <vector>

using namespace std;

#define NMAX 100100

vector<pair<int, int> > ad[NMAX], bd[NMAX];
map<int, int> total_primes;

int N, M, i, j, k, x;

#define MAX_PRIME 3162
#define NUM_PRIMES 1300

int np;
int small_primes[NUM_PRIMES];

void genSmallPrimes() {
	np = 3;
	small_primes[1] = 2;
	small_primes[2] = 3;
	small_primes[3] = 5;

	for (i = 7; i <= MAX_PRIME; i++) {
		for (j = 2; j * j <= i; j++)
			if ((i % j) == 0) {
				break;
			}
		if (j * j > i) {
			np++;
			small_primes[np] = i;
			//printf("new prime: %d\n", i);
		}
	}
	//printf("np=%d\n", np);
}

int main() {
	genSmallPrimes();
	
	//freopen("222c.txt", "r", stdin);
	scanf("%d %d", &N, &M);
	
	for (i = 1; i <= N; i++) {
		scanf("%d", &x);
		for (j = 1; j <= np && small_primes[j] * small_primes[j] <= x; j++) {
			if ((x % small_primes[j]) == 0) {
				int cnt = 0;
				while ((x % small_primes[j]) == 0) {
					cnt++;
					x /= small_primes[j];
				}
				ad[i].push_back(make_pair(small_primes[j], cnt));
				total_primes[small_primes[j]] += cnt;
			}
		}
		
		if (x > 1) {
			ad[i].push_back(make_pair(x, 1));
			total_primes[x]++;
		}
	}
	
	for (i = 1; i <= M; i++) {
		scanf("%d", &x);
		for (j = 1; j <= np && small_primes[j] * small_primes[j] <= x; j++) {
			if ((x % small_primes[j]) == 0) {
				int cnt = 0;
				while ((x % small_primes[j]) == 0) {
					cnt++;
					x /= small_primes[j];
				}
				bd[i].push_back(make_pair(small_primes[j], cnt));
				total_primes[small_primes[j]] -= cnt;
			}
		}
		
		if (x > 1) {
			bd[i].push_back(make_pair(x, 1));
			total_primes[x]--;
		}
	}
	
	printf("%d %d\n", N, M);
	for (i = 1; i <= N; i++) {
		int number = 1;
		for (j = 0; j < ad[i].size(); j++) {
			int prime = ad[i][j].first;
			int cnt = ad[i][j].second;
			cnt = min(cnt, total_primes[prime]);
			if (cnt < 0)
				cnt = 0;
			for (k = 1; k <= cnt; k++)
				number *= prime;
			if (cnt > 0)
				total_primes[prime] -= cnt;
		}
		
		printf("%d", number);
		if (i < N)
			printf(" ");
	}
	printf("\n");

	for (i = 1; i <= M; i++) {
		int number = 1;
		for (j = 0; j < bd[i].size(); j++) {
			int prime = bd[i][j].first;
			int cnt = bd[i][j].second;
			cnt = min(cnt, -total_primes[prime]);
			if (cnt < 0)
				cnt = 0;
			for (k = 1; k <= cnt; k++)
				number *= prime;
			if (cnt > 0)
				total_primes[prime] += cnt;
		}
		
		printf("%d", number);
		if (i < M)
			printf(" ");
	}
	printf("\n");
	
	return 0;
}
