#include <stdio.h>
#include <string.h>

#define MOD 1000000007
#define NMAX 2100
#define LOGMAX 31

int a[NMAX], b[NMAX], bit[LOGMAX];
long long coef[LOGMAX][NMAX], oldccoef[NMAX], newccoef[NMAX];
int N, K, i, j, x, d, dd;

void read_input() {
	//freopen("223c.txt", "r", stdin);
	scanf("%d %d", &N, &K);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);
}

void smart_sol() {
	memset(coef, 0, sizeof(coef));
	for (d = 0; d <= N; d++)
		coef[0][d] = 1;
	
	for (x = 1; x < LOGMAX; x++) {
		for (d = 0; d <= N; d++) {
			for (dd = 0; dd <= d; dd++) {
				coef[x][d] = (coef[x][d] + coef[x - 1][dd] * coef[x - 1][d - dd]) % MOD;
			}
		}
	}

	bit[0] = 1;
	for (x = 1; x < LOGMAX; x++)
		bit[x] = bit[x - 1] * 2;

	memset(newccoef, 0, sizeof(newccoef));
	newccoef[0] = 1;
	
	for (x = 0; x < LOGMAX; x++)
		if ((K & bit[x]) > 0) {
			memcpy(oldccoef, newccoef, sizeof(newccoef));
			memset(newccoef, 0, sizeof(newccoef));
			for (d = 0; d <= N; d++) {
				for (dd = 0; dd <= d; dd++)
					newccoef[d] = (newccoef[d] + oldccoef[dd] * coef[x][d - dd]) % MOD;
			}
		}

	/*
	fprintf(stderr, "N=%d, K=%d\n", N, K);		
	for (d = 0; d <= N; d++)
		fprintf(stderr, "%d ", newccoef[d]);
	fprintf(stderr, "\n");
	*/
		
	memset(b, 0, sizeof(b));
	for (i = 1; i <= N; i++) {
		for (j = 0; i + j <= N; j++) {		
			b[i + j] = (b[i + j] + newccoef[j] * a[i]) % MOD;
		}
	}
	
	for (i = 1; i <= N; i++) {
		printf("%d", b[i]);
		if (i < N)
			printf(" ");
	}
	printf("\n");
}

void brute_force() {
	int sp;
	for (i = 1; i <= K; i++) {
		sp = 0;
		for (int i = 1; i <= N; i++) {
			sp = (sp + a[i]) % MOD;
			a[i] = sp;
		}
	}

	for (i = 1; i <= N; i++) {
		printf("%d", a[i]);
		if (i < N)
			printf(" ");
	}
	printf("\n");
}

int main() {	
	read_input();
	smart_sol();
	//brute_force();
	return 0;
}
