#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define MOD 1000000007
#define NMAX 101

int N, K, i, j, p;
long long M;

vector<long long> pexp;
int comb[NMAX][NMAX];
long long pcomb[NMAX][2];
int nways[NMAX][NMAX * NMAX];

void computeComb() {
	memset(comb, 0, sizeof(comb));
	comb[1][0] = comb[1][1] = 1;
	for (i = 2; i <= N; i++)  {
		comb[i][0] = 1;
		for (j = 1; j <= i; j++) {
			comb[i][j] = (comb[i - 1][j - 1] + comb[i - 1][j]) % MOD;
		}
	}
}

#define BMAX 63
long long bit[BMAX];

void computePow() {
	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2;

	for (i = 0; i <= N; i++)
		for (j = 0; j < pexp.size(); j++) {
			// compute (comb[N][i] ^ pexp[j]) % MOD.
			long long result = 1;
			for (p = BMAX - 1; p >= 0; p--) {
				result = (result * result) % MOD;
				if ((pexp[j] & bit[p]) > 0) {
					result = (result * (long long) comb[N][i]) % MOD;
				}
			}
			pcomb[i][j] = result;
			//printf("(%d,%d) : %d^(exp=%I64d) = %I64d\n", i, j, comb[N][i], pexp[j], pcomb[i][j]);
		}
}

void computeNways() {
	memset(nways, 0, sizeof(nways));
	nways[0][0] = 1;
	for (i = 1; i <= N; i++) {
		for (j = 0; j <= K && j <= i * N; j++) {
			for (p = 0; p <= N && p <= j; p++) {
				long long x;
				
				if (((M - i) / N + 1) == pexp[0])
					x = pcomb[p][0];
				else
					x = pcomb[p][1];
				
				long long y = nways[i - 1][j - p];
				y = (x * y) % MOD;

				//fprintf(stderr, "i=%d,j=%d,p=%d, x=%I64d, y=%I64d\n", i, j, p, x, y);

				nways[i][j] = ((long long) nways[i][j] + y) % MOD;
			}
			
			//printf("nways[%d][%d]=%d\n", i, j, nways[i][j]);
		}
	}
}

int main() {
	//freopen("x.txt", "r", stdin);

	scanf("%d %I64d %d", &N, &M, &K);
	computeComb();
	
	pexp.push_back((M - 1) / N + 1);
	if ((M - N) / N != (M - 1) / N)
		pexp.push_back((M - N) / N + 1);
	
	computePow();
	
	computeNways();
	printf("%d\n", nways[N][K]);
	return 0;
}
