#include <stdio.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <set>

using namespace std;

#define NMAX 1001

set<pair<double, int> > m[2];
set<pair<double, int> >::iterator it;
int c[NMAX], a[NMAX], b[NMAX], visited[NMAX];
char poz[NMAX];
int hl, hr, N, smax;
int L, H, i;
double pi;

void Test(double u) {
	fprintf(stderr, "u=%.6lf\n", u);

	int y;
	double L1;
	
	if (u < 0.5 * pi) {
		y = 0;
		L1 = hl * sin(u) / fabs(cos(u));
	} else {
		y = 1;
		L1 = (H - hl) * sin(u) / fabs(cos(u));
	}
	
	double LL = H * sin(u) / fabs(cos(u));
	int ok = 1, s = 0;
	memset(visited, 0, sizeof(visited));

	fprintf(stderr, "Testing u=%.9lf L1=%.6lf y=%d LL=%.6lf\n", u, L1, y, LL);

	while (1) {
		fprintf(stderr, "Current pos: L1=%.6lf y=%d LL=%.6lf\n", L1, y, LL);

		it = m[y].lower_bound(make_pair(L1, N + 1));
		if (it == m[y].end()) {
			ok = 0;
			break;
		}
			
		i = it->second;

		fprintf(stderr, "i=%d a=%d b=%d\n", i, a[i], b[i]);

		if (visited[i] || (L1 < a[i] && fabs(L1 - a[i]) > 0.000001)) {
			ok = 0;
			break;
		}
			
		visited[i] = 1;
		s += c[i];
		y = 1 - y;
		L1 += LL;
			
		if (L1 > L) {
			break;
		}
	}

	if (ok && s > smax)
		smax = s;
}

int main() {
	//freopen("input.txt", "r", stdin);
	scanf("%d %d %d", &hl, &hr, &N);
	//fprintf(stderr, "hl=%d hr=%d N=%d\n", hl, hr, N);

	for (i = 1; i <= N; i++) {
		scanf("%d %c %d %d", &c[i], &poz[i], &a[i], &b[i]);

		if (poz[i] == 'F')
			m[0].insert(make_pair((double) b[i] + 0.000001, i));
		else
			m[1].insert(make_pair((double) b[i] + 0.000001, i));
	}

	//fprintf(stderr, "kk\n");
	
	L = 100000;
	H = 100;

	smax = 0;
	pi = 2.0 * acos(0.0);

	for (int x = 0; x < N; x++) {
		fprintf(stderr, "x=%d\n", x);

		double li, ls, mid, L1, LL, LLL, z, Lfinal, Ltarget;
		li = 1e-9;
		ls = pi / 2 - 1e-9;
		while (fabs(li - ls) > 1e-9) {
			mid = 0.5 * (li + ls);
			L1 = hl * sin(mid) / fabs(cos(mid));
			LL = H * sin(mid) / fabs(cos(mid));

			if (L1 > L) {
				ls = mid;
				continue;
			}

			LLL = (double) L - L1;
			z = floor (LLL / LL);
			while (LL * z > LLL)
				z--;

			//fprintf(stderr, "x=%d mid=%.6lf L1=%.6lf LL=%.6lf LLL=%.6lf z=%.0lf\n", x, mid, L1, LL, LLL, z);
			
			if (z > x)
				li = mid;
			else if (z < x)
				ls = mid;
			else {
				Lfinal = LLL - z * LL;			
				if (x % 2 == 0)
					Ltarget = hr * sin(mid) / fabs(cos(mid));
				else
					Ltarget = (H - hr) * sin(mid) / fabs(cos(mid));
			
				//fprintf(stderr, "Lfinal=%.6lf Ltarget=%.6lf\n", Lfinal, Ltarget);
				
				if (Lfinal < Ltarget)
					ls = mid;
				else
					li = mid;
			}
		}
		
		Test(li);		


		li = 1e-9;
		ls = pi / 2 - 1e-9;
		while (fabs(li - ls) > 1e-9) {
			mid = 0.5 * (li + ls);
			L1 = (H - hl) * sin(mid) / fabs(cos(mid));
			LL = H * sin(mid) / fabs(cos(mid));

			if (L1 > L) {
				ls = mid;
				continue;
			}

			LLL = (double) L - L1;
			z = floor (LLL / LL);
			while (LL * z > LLL)
				z--;

			//fprintf(stderr, "x=%d mid=%.6lf L1=%.6lf LL=%.6lf LLL=%.6lf z=%.0lf\n", x, mid, L1, LL, LLL, z);
			
			if (z > x)
				li = mid;
			else if (z < x)
				ls = mid;
			else {
				Lfinal = LLL - z * LL;			
				if (x % 2 == 0)
					Ltarget = (H - hr) * sin(mid) / fabs(cos(mid));
				else
					Ltarget = hr * sin(mid) / fabs(cos(mid));
			
				//fprintf(stderr, "Lfinal=%.6lf Ltarget=%.6lf\n", Lfinal, Ltarget);
				
				if (Lfinal < Ltarget)
					ls = mid;
				else
					li = mid;
			}
		}
		
		Test(pi - li);
	}

	printf("%d\n", smax);
	
	return 0;
}
