#include <stdio.h>
#include <math.h>

#define eps 1e-10

double yy1, yy2, yw, xb, yb, r, li, ls, mid, yhit, d, dy2, ans, a, b, c;

double GetY(double xw) {
	d = (yw - yb) * xb / (xb - xw); 
	return yw - (d - (yw - yb));
}

double GetX(double yt) {
	li = eps; ls = xb - eps;
	while (fabs(ls - li) > eps) {
		mid = 0.5 * (li + ls);
		yhit = GetY(mid);
		if (yhit < yt) {
			ls = mid;
		} else {
			li = mid;
		}
	}

	dy2 = ((yy2 - yt) * li) / (yw - yt);
	
	if (dy2 < r)
		return -1.0;

	dy2 = li * li + (yw - yy2) * (yw - yy2);
	if (dy2 < r * r)
		return -1.0;
	
	a = yt - yw;
	b = li;
	c = -li * yt;
	
	dy2 = fabs(b * yy2 + c) / sqrt(a * a + b * b);
	//fprintf(stderr, "a=%lf b=%lf c=%lf dy2=%lf r=%lf\n", a, b, c, dy2, r);
	if (dy2 < r)
		return -1.0;
	
	return li;
}

int main() {
	scanf("%lf %lf %lf %lf %lf %lf", &yy1, &yy2, &yw, &xb, &yb, &r);
	yw -= r;
	
	ans = GetX(yy1 + r);
	if (ans < 0.0)
		ans = GetX(yy2 - r);
	if (ans < 0.0)
		ans = GetX(0.5 * (yy1 + yy2));

	if (ans < 0.0)
		printf("-1\n");
	else
		printf("%.9lf\n", ans);
	
	return 0;
}
