// Mugurel Ionut Andreica - O(N*log(N))

#include <stdio.h>
#include <math.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define NMAX 131072
#define eps 1e-9

#define max(a, b) ((a) >= (b) ? (a) : (b))

vector<pair<double, pair<double, int> > > p;
vector<pair<int, int> > updv;
set<pair<double, pair<double, int> > > ycoord;
set<pair<double, pair<double, int> > >::iterator it;
map<double, int> ycoord_map;
int v[NMAX << 1];
int N;

void read_input() {
	int i, x, y, a, b, c, d;
	double a1, a2, u, r, xx, yy;
	
	//freopen("x.txt", "r", stdin);

	scanf("%d", &N);
	scanf("%d/%d %d/%d", &a, &b, &c, &d);
	a1 = atan2(a, b);
	a2 = atan2(c, d);
	
	for (i = 1; i <= N; i++) {
		scanf("%d %d", &x, &y);
		u = atan2(y, x);
		
		if (a1 < u && u < a2 && fabs(u - a1) > eps && fabs(u - a2) > eps) {
			r = sqrt((double) x * (double) x + (double) y * (double) y);
			xx = r * sin(u - a1);
			yy = r * sin(a2 - u);
			p.push_back(make_pair(xx, make_pair(yy, i)));
			ycoord.insert(make_pair(yy, make_pair(-xx, i)));
		}
	}
}

int query(int a) {
	int b = NMAX + a - 1, result = 0;
	while (b > 1) {
		if ((b & 1) == 0) {
			// b is the left son of its parent.
			result = max(result, v[b + 1]);
		}
		b = b >> 1;
	}
	return result;
}

void update(int a, int val) {
	int b = NMAX + a - 1;
	while (b >= 1) {
		v[b] = max(v[b], val);
		b = b >> 1;
	}
}

void compute() {
	int i, j, M, lmax;
	double lasty = -1.0;
	for (M = 0, it = ycoord.begin(); it != ycoord.end(); it++) {
		M++;
		if (fabs(lasty - it->first) < eps)
			M--;
		ycoord_map[it->second.second] = M;
		lasty = it->first;
	}

	sort(p.begin(), p.end());
	for (i = p.size() - 1; i >= 0; i--) {
		if (i < (int) (p.size()) - 1 && fabs(p[i].first - p[i + 1].first) > eps) {
			for (j = 0; j < updv.size(); j++)
				update(updv[j].first, updv[j].second);
			updv.clear();
		}

		j = ycoord_map[p[i].second.second];
		lmax = query(j);
		lmax++;
		//fprintf(stderr, "xx=%lf yy=%lf idx=%d j=%d lmax=%d\n", p[i].first, p[i].second.first, p[i].second.second, j, lmax);
		updv.push_back(make_pair(j, lmax));
	}

	for (j = 0; j < updv.size(); j++)
		update(updv[j].first, updv[j].second);
	updv.clear();
}

void write_output() {
	printf("%d\n", v[1]);
}

int main() {
	read_input();
	compute();
	write_output();
}
