#include <stdio.h>

#define NMAX 111

int q[NMAX], qinv[NMAX], t[NMAX], s[NMAX];
int qq[NMAX][NMAX], qqinv[NMAX][NMAX];
int N, k, i, j, p, is_possible[NMAX][NMAX], is_equal;
long long answer;

void ComputeInv() {
	int i;
	for (i = 1; i <= N; i++)
		qinv[q[i]] = i;
}

void Compose(int p1[], int p2[], int p3[]) {
	int i;
	for (i = 1; i <= N; i++)
		p3[i] = p1[p2[i]];
}

int IsEqual(int p1[], int p2[]) {
	int i;
	for (i = 1; i <= N; i++)
		if (p1[i] != p2[i])
			return 0;
	return 1;
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &N, &k);
	for (i = 1; i <= N; i++)
		scanf("%d", &q[i]);
	for (i = 1; i <= N; i++)
		scanf("%d", &s[i]);
	ComputeInv();

	for (i = 1; i <= N; i++) {
		qq[0][i] = qqinv[0][i] = i;
	}
	
	for (p = 1; p <= k; p++) {
		Compose(qq[p - 1], q, qq[p]);
		Compose(qqinv[p - 1], qinv, qqinv[p]);
	}

	is_possible[0][0] = 1;
	if (IsEqual(qq[0], s)) {
		is_possible[0][0] = 0;
	}
	
	for (i = 0; i <= k; i++)
		for (j = 0; j <= k && i + j <= k; j++) {
			if (i == 0 && j == 0)
				continue;
			Compose(qq[i], qqinv[j], t);
			
			/*
			fprintf(stderr, "i=%d j=%d k=%d:", i, j, k);
			for (p = 1; p <= N; p++)
				fprintf(stderr, " %d", t[p]);
			fprintf(stderr, "\n");
			*/
			
			is_possible[i][j] = 0;
			if (i > 0 && is_possible[i - 1][j])
				is_possible[i][j] = 1;
			if (j > 0 && is_possible[i][j - 1])
				is_possible[i][j] = 1;
			is_equal = IsEqual(s, t);
			if (is_equal && (i + j < k))
				is_possible[i][j] = 0;
			if (!is_equal && (i + j == k))
				is_possible[i][j] = 0;
		}
	
	for (i = 0; i <= k; i++) {
		if (is_possible[i][k - i]) {
			printf("YES\n");
			return 0;
		}
	}

	printf("NO\n");	
	return 0;
}
