#include <stdio.h>

int N, l, c;
long long CNT, li, ls, mid, ans, a1, a2;

long long OutCorner(long long d, long long turn) {
	if (turn <= d)
		return 0;
	long long dif = turn - d, ans;
	ans = dif * (dif + 1) / 2;
	//fprintf(stderr, "OutCorner(%I64d,%I64d)=%I64d\n", d, turn, ans);
	return ans;
}

long long OutSide(long long d, long long turn) {
	if (turn <= d)
		return 0;
	long long dif = turn - d, ans;
	ans = 2 * (dif * (dif + 1) / 2) - dif;
	//fprintf(stderr, "OutSide(%I64d,%I64d)=%I64d\n", d, turn, ans);
	return ans;
}

long long Count(long long turn) {
	long long total = 1 + 4 * (turn * (turn + 1) / 2);
	total -= OutSide(l - 1, turn);
	total -= OutSide(c - 1, turn);
	total -= OutSide(N - l, turn);
	total -= OutSide(N - c, turn);
	total += OutCorner(l - 1 + c - 1 + 1, turn);
	total += OutCorner(l - 1 + N - c + 1, turn);
	total += OutCorner(N - l + c - 1 + 1, turn);
	total += OutCorner(N - l + N - c + 1, turn);
	//fprintf(stderr, "Count(%I64d)=%I64d\n", turn, total);
	return total;
}

long long CountBrute(long long turn) {
	long long total = 0;
	int i, j;
	long long di, dj;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) {
			di = i - l;
			if (di < 0)
				di = -di;
			dj = j - c;
			if (dj < 0)
				dj = -dj;
			if (di + dj <= turn)
				total++;
		}
	
	return total;
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d %d %I64d", &N, &l, &c, &CNT);
	
	li = 0;
	ls = 2 * N;
	ans = -1;

	while (li <= ls) {
		mid = li + (ls - li) / 2;
		a1 = Count(mid);
		//a2 = CountBrute(mid);
		//fprintf(stderr, "### %I64d: %I64d %I64d\n", mid, a1, a2);
		if (a1 >= CNT) {
			ans = mid;
			ls = mid - 1;
		} else
			li = mid + 1;
	}
	
	printf("%I64d\n", ans);	
	return 0;
}
