#include <stdio.h>
#include <string.h>

#define MOD 1000000007
#define DMAX 11

long long nmax[DMAX] = {0, 9, 99, 999, 9999, 99999, 999999, 9999999, 99999999, 999999999, 9999999999LL};
long long P[DMAX][DMAX];
long long cnt[DMAX][DMAX][DMAX], C[DMAX][DMAX], totalcnt[DMAX][DMAX], tmp;
long long nsel[DMAX][DMAX][DMAX][DMAX][DMAX], fact[DMAX], nways;
int N, x, y, len, i, j, jstart, nx, ny, cnx, cny, difx, dify, nextx, nexty;

void ComputeComb() {
	int i, j;
	C[0][0] = 1;
	for (i = 1; i < DMAX; i++) {
		C[i][0] = 1;
		for (j = 1; j <= i; j++) {
			C[i][j] = (C[i - 1][j - 1] + C[i - 1][j]) % MOD;
		}
	}
}

inline int extended_gcd(long long A, long long B, long long &X, long long &Y) {
	if (B == 0) {
		X = 1;
		Y = 0;
		return A;
	}

	long long X0, Y0, D;
	D = extended_gcd(B, A % B, X0, Y0);
	X = Y0;
	Y = X0 - (A / B) * Y0;
	return D;
}

long long inv[DMAX];

void ComputeInv() {
	long long garbage;
	for (int i = 1; i < DMAX; i++) {
		extended_gcd(i, MOD, inv[i], garbage);
		inv[i] %= MOD;
		while (inv[i] < 0)
			inv[i] += MOD;
		//fprintf(stderr, "i=%d inv=%I64d\n", i, inv[i]);
	}
}

void ComputeFact() {
	fact[0] = 1;
	for (int i = 1; i < DMAX; i++) {
		fact[i] = (fact[i - 1] * i) % MOD;
	}
}

void ComputeP() {
	int i, j;
	for (i = 0; i < DMAX; i++) {
		P[i][0] = 1;
		for (j = 1; j < DMAX; j++)
			P[i][j] = (P[i][j - 1] * i) % MOD;
	}
}

int digits[DMAX], ndigits;

void GetN(int N) {
	ndigits = 0;
	while (N > 0) {
		digits[ndigits] = N % 10;
		N /= 10;
		ndigits++;
	}
}

long long totalcnt2[DMAX][DMAX];

void TestBruteForce() {
	int x, y, i, j;
	for (i = 1; i <= N; i++) {
		x = y = 0;
		j = i;
		while (j > 0) {
			if (j % 10 == 4)
				x++;
			else if (j % 10 == 7)
				y++;
			j /= 10;
		}
		totalcnt2[x][y]++;
	}
	
	for (x = 0; x < DMAX; x++)
		for (y = 0; y < DMAX; y++)
			if (totalcnt[x][y] != totalcnt2[x][y]) {
				fprintf(stderr, "!!! x=%d y=%d: %I64d %I64d\n", x, y, totalcnt[x][y], totalcnt2[x][y]);
			}
}

int main() {
	ComputeComb();
	ComputeInv();
	ComputeFact();
	ComputeP();
	
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	GetN(N);

	for (len = 1; len < DMAX; len++)
		for (x = 0; x < DMAX && x <= len; x++)
			for (y = 0; y < DMAX && x + y <= len; y++) {
				cnt[len][x][y] = 0;
				if (len < ndigits) {
					if (x == 0 && y == 0)
						tmp = P[8][len] % MOD;
					else {
						tmp = (C[len][x] * C[len - x][y]);
						tmp = (tmp * P[8][len - x - y]);
					}
					cnt[len][x][y] = tmp;
				} else if (len == ndigits) {
					nx = ny = 0;
					for (i = ndigits - 1; i >= 0; i--) {
						if (i == ndigits - 1)
							jstart = 1;
						else
							jstart = 0;
						
						for (j = jstart; j < digits[i]; j++) {
							cnx = nx; cny = ny;
							if (j == 4)
								cnx++;
							else if (j == 7)
								cny++;

							if (cnx <= x && cny <= y) {
								difx = x - cnx;
								dify = y - cny;

								if (difx == 0 && dify == 0)
									cnt[len][x][y] = (cnt[len][x][y] + P[8][i]);
								else
									cnt[len][x][y] = (cnt[len][x][y] + cnt[i][difx][dify]);
							}
						}
						
						if (digits[i] == 4)
							nx++;
						else if (digits[i] == 7)
							ny++;
					}

					if (nx == x && ny == y)
						cnt[len][x][y]++;
				}

				if (len >= ndigits - 1) {
					totalcnt[x][y] += cnt[len][x][y];
					if (x == 0 && y == 0 && len == ndigits - 1)
						totalcnt[x][y]--;
				}
				//fprintf(stderr, "len=%d x=%d y=%d: %I64d\n", len, x, y, cnt[len][x][y]);
			}

	for (x = 0; x < DMAX; x++)
		for (y = 0; y < DMAX; y++)
			if (totalcnt[x][y] > 0) {
				//fprintf(stderr, "x=%d y=%d totalcnt=%I64d\n", x, y, totalcnt[x][y]);
			}

	//TestBruteForce();
			
	nways = 1;	
	for (i = 0; i <= 6; i++) {
		if (i > 0) {
			nways = (nways * (totalcnt[0][0] - i + 1)) % MOD;
			nways = (nways * inv[i]) % MOD;
		}
		nsel[0][0][0][0][i] = nways;
	}
	
	for (x = 0; x < DMAX; x++)
		for (y = 0; y < DMAX; y++)
			for (nx = 0; nx < DMAX; nx++)
				for (ny = 0; ny < DMAX; ny++)
					for (i = 0; i <= 6; i++)
						if (nsel[x][y][nx][ny][i] > 0) {
							//if (x == 0 && y == 0)
							//fprintf(stderr, "x=%d y=%d nx=%d ny=%d i=%d: %I64d\n", x, y, nx, ny, i, nsel[x][y][nx][ny][i]);
							cnx = x;
							cny = y + 1;
							if (cny >= DMAX) {
								cnx++;
								cny = 0;
							}
							
							if (cnx >= DMAX)
								break;

							nways = 1;
							for (j = 0; j <= 6; j++) {
								nextx = nx + j * cnx;
								nexty = ny + j * cny;
								if (nextx >= DMAX || nexty >= DMAX || i + j > 6)
									break;

								if (j > 0) {
									nways = (nways * (totalcnt[cnx][cny] - j + 1)) % MOD;
									nways = (nways * inv[j]) % MOD;
								}
								
								tmp = (nways * nsel[x][y][nx][ny][i]) % MOD;
								nsel[cnx][cny][nextx][nexty][i + j] =
								(nsel[cnx][cny][nextx][nexty][i + j] + tmp) % MOD;
							}
						}

	long long answer = 0;
	for (x = 0; x < DMAX; x++)
		for (y = 0; y < DMAX; y++)
			for (nx = 0; nx < DMAX; nx++)
				for (ny = 0; ny < DMAX; ny++)
					if (nx + ny < x + y) {
						tmp = totalcnt[x][y];
						tmp = (tmp * nsel[DMAX - 1][DMAX - 1][nx][ny][6]) % MOD;
						answer = (answer + tmp) % MOD;
					}

	printf("%I64d\n", (answer * fact[6]) % MOD);
	return 0;
}
