#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define MOD 1000000007
#define VMAX 100001
#define NMAX 100001

vector<int> v, divisors;
long long p2[NMAX], cnt[VMAX], answer, total;
int N, i, j, icnt[NMAX], dif;

int FindCountGEQ(int X) {
	int li, ls, mid, ans = 0;
	li = 0; ls = N - 1;
	while (li <= ls) {
		mid = (li + ls) / 2;
		if (v[mid] >= X) {
			ans = N - mid;
			ls = mid - 1;
		} else {
			li = mid + 1;
		}
	}
	return ans;
}

#define BMAX 30

int bit[BMAX];

long long raise_to_pow(int x, int y) {
	long long result = 1;
	for (int b = BMAX - 1; b >= 0; b--) {
		result = (result * result) % MOD;
		if ((y & bit[b]) > 0) {
			result = (result * x) % MOD;
		}
	}
	return result;
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	v.resize(N);
	for (i = 0; i < N; i++)
		scanf("%d", &v[i]);
	
	sort(v.begin(), v.end());

	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2;
	
	answer = 0;
	
	for (i = 1; i < VMAX; i++)
		icnt[i] = FindCountGEQ(i);

	for (i = 1; i < VMAX; i++) {
		if (icnt[i] == 0)
			break;

		divisors.clear();
		divisors.push_back(1);
		for (j = 2; j * j <= i; j++)
			if (i % j == 0) {
				divisors.push_back(j);
				if (j * j != i)
					divisors.push_back(i / j);
			}

		if (i > 1)
			divisors.push_back(i);
		sort(divisors.begin(), divisors.end());

		total = 1;
		for (j = 1; j < divisors.size(); j++) {
			dif = icnt[divisors[j - 1]] - icnt[divisors[j]];
			total = (total * raise_to_pow(j, dif)) % MOD;
		}
		
		total = (total * ((raise_to_pow(divisors.size(), icnt[i]) - raise_to_pow(divisors.size() - 1, icnt[i]) + MOD) % MOD)) % MOD;
		//fprintf(stderr, "i=%d: total=%I64d\n", i, total);
		answer = (answer + total) % MOD;
	}
	
	printf("%I64d\n", answer);
	return 0;
}
