#include <stdio.h>
#include <string.h>

#define NMAX 256

char model[NMAX][NMAX], A[NMAX][NMAX];
int N, K, i, j, p, q, u, v, step, dim, size, next_size;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d %d", &N, &K);
	for (i = 0; i < N; i++)
		scanf("%s", model[i]);

	dim = 1;
	for (i = 1; i <= K; i++)
		dim *= N;

	for (i = 0; i < dim; i++)
		for (j = 0; j < dim; j++)
			A[i][j] = '.';
	
	size = dim;
	for (step = 1; step <= K; step++) {
		next_size = size / N;
		for (i = 0; i < dim; i += size)
			for (j = 0; j < dim; j += size)
				if (A[i][j] == '.') {
					// Apply the model.
					for (p = 0; p < size; p += next_size)
						for (q = 0; q < size; q += next_size)
							if (model[p / next_size][q / next_size] == '*') {
								for (u = i + p; u < i + p + next_size; u++)
									for (v = j + q; v < j + q + next_size; v++)
										A[u][v] = '*';
							}
				}
		size = next_size;
	}

	for (i = 0; i < dim; i++) {
		for (j = 0; j < dim; j++)
			printf("%c", A[i][j]);
		printf("\n");
	}
	
	return 0;
}
