#include <stdio.h>
#include <string.h>

#define NMAX 101

char marked[10];
int G[NMAX][NMAX];
int T, K, M, N, i, j;

int Grundy(int K, int M, int N, int i, int j) {
	int di = M - i, dj = N - j;
	if (di <= K - 1 || dj <= K - 1)
		return (di + dj) % 2;

	di -= K;
	dj -= K;
	if ((di % (K + 1) == 0 && dj >= di) || (dj % (K + 1) == 0 && di >= dj))
		return 2 + (di + dj) % 2;

	if (K == 1) {
		return (di + dj) % 2;
	} else {
		if (di <= dj)
			return (di + dj + 1 + (di / (K + 1))) % 2;
		else
			return (di + dj + 1 + (dj / (K + 1))) % 2;
	}
}

void BruteForceGrundy() {
	for (i = M; i >= 1; i--)
		for (j = N; j >= 1; j--) {
			if (i == M && j == N)
				G[i][j] = 0;
			else {
				memset(marked, 0, sizeof(marked));
				if (i < M)
					marked[G[i + 1][j]] = 1;
				if (j < N)
					marked[G[i][j + 1]] = 1;
				if (i <= M - K && j <= N - K)
					marked[G[i + K][j + K]] = 1;
				
				G[i][j] = 0;
				while (marked[G[i][j]])
					G[i][j]++;
			}
		}

	fprintf(stderr, "K=%d M=%d N=%d\n", K, M, N);
	for (i = 1; i <= M; i++) {
		for (j = 1; j <= N; j++) {
			if (G[i][j] != Grundy(K, M, N, i, j))
				fprintf(stderr, "!(%d,%d)", i, j);
			fprintf(stderr, "%d ", G[i][j]);
		}
		fprintf(stderr, "\n");
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d %d", &T, &K);
	
	while (T--) {
		scanf("%d %d", &M, &N);
		if (Grundy(K, M, N, 1, 1) > 0)
			printf("+\n");
		else
			printf("-\n");
	}

	return 0;
}
