#include <stdio.h>
#include <string.h>

#define maxc 11000
#define baza 100000000
#define fwd 10
#define writestring "%08d"

#define INT int

typedef INT BigNum[maxc];
long long x;

void multbig(BigNum n1, BigNum n2, BigNum rez) {
    int i, j, ndigits = n1[0] + n2[0] - 1;
    memset(rez, 0, (ndigits + fwd + 1) * sizeof(int));
    for (i = 1; i <= n1[0]; i++)
        for (j = 1; j <= n2[0]; j++) {
            x = (long long) (n1[i]) * (long long) (n2[j]);
            rez[i + j - 1] += (x % baza);
            rez[i + j] += (x / baza);
            if (rez[i + j - 1] >= baza) {
                rez[i + j] += (rez[i + j - 1] / baza);
                rez[i + j - 1] %= baza;
            }
        }

    for (i = 1; i <= (ndigits + fwd); i++)
        if (rez[i] >= baza) {
            rez[i + 1] += (rez[i] / baza);
            rez[i] %= baza;
    }

    for (i = (ndigits+fwd); i >= 1; i--)
        if (rez[i] > 0) {
            rez[0] = i;
            break;
    }

    if (!rez[0])
        rez[0] = 1;
}

#define LMAX 10000
#define STEP 1500

BigNum a, b, c;
int i, j, L;

int main() {
    freopen("tamplar.cpp", "w", stdout);

    a[0] = a[1] = 1;
    for (i = 2; i < LMAX; i++) {
        b[0] = 1; b[1] = (INT) i;
        multbig(a, b, c);
        memcpy(a, c, (c[0] + 1) * sizeof(INT));

        if (i % STEP == 0) {
            printf("{");
            for (j = 0; j <= a[0]; j++)
                printf("%d,", a[j]);
            for (j = a[0] + 1; j < maxc; j++) {
                printf("0");
                if (j < maxc - 1)
                    printf(",");
            }
            printf("},\n");
        }
    }

    return 0;
}
