#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define MAXLS 1000000000LL

int IsPrime(int X) {
	for (int Y = 2; Y * Y <= X; Y++)
		if (X % Y == 0)
			return 0;
	return 1;
}

int IsSquareOfPrimeNumber(long long X) {
	long long li, ls, mid, Y = 1;
	li = 1; ls = MAXLS;
	while (li <= ls) {
		mid = (li + ls) / 2;
		if (mid * mid <= X) {
			Y = mid;
			li = mid + 1;
		} else {
			ls = mid - 1;
		}
	}
	
	if (Y * Y == X && IsPrime((int) Y))
		return 1;
	return 0;
}

#define PMAX 1000001
#define MAXPRIMES 79000

char *is_not_prime;
int primes[MAXPRIMES], np;

void FindSmallPrimes() {
	is_not_prime = new char[PMAX];
	for (int i = 2; i < PMAX; i++)
		is_not_prime[i] = 0;
	
	np = 0;
	for (int i = 2; i < PMAX; i++) {
		if (is_not_prime[i])
			continue;

		np++;
		primes[np] = i;

		for (int j = 2 * i; j < PMAX; j += i)
			is_not_prime[j] = 1;
	}
	//fprintf(stderr, "np=%d\n", np);

	delete is_not_prime;
}

#define EXPMAX 60
#define XMAX 1000000000000000000LL

long long* pp[MAXPRIMES];
unsigned char maxp[MAXPRIMES];
long long pptmp[EXPMAX];

void ComputePrimePowers() {
	int smaxp = 0;

	for (int i = 1; i <= np; i++) {
		pptmp[0] = primes[i];
		maxp[i] = 1;
		
		while (primes[i] <= XMAX / pptmp[maxp[i] - 1]) {
			pptmp[maxp[i]] = pptmp[maxp[i] - 1] * (long long) primes[i];
			maxp[i]++;
		}

		smaxp += maxp[i];
		
		pp[i] = new long long[maxp[i]];
		memcpy(pp[i], pptmp, maxp[i] * sizeof(long long));
	}

	//fprintf(stderr, "smaxp=%d\n", smaxp);
}

int main() {
	int T, b, li, ls, mid, idx;
	long long X;

	FindSmallPrimes();
	ComputePrimePowers();
	
	freopen("ubercool.in", "r", stdin);
	freopen("ubercool.out", "w", stdout);
	
	scanf("%d", &T);
	while (T--) {
		scanf("%lld", &X);
		if (X <= 3) {
			printf("NU\n");
			continue;
		}
		
		if (IsSquareOfPrimeNumber(X)) {
			printf("DA\n");
		} else {
			for (b = 3; b <= EXPMAX; b++) {
				li = 1; ls = np; idx = 0;
				while (li <= ls) {
					mid = (li + ls) / 2;
					if (maxp[mid] < b || pp[mid][b - 1] > X) {
						ls = mid - 1;
					} else {
						idx = mid;
						li = mid + 1;
					}
				}
				
				if (idx > 0 && pp[idx][b - 1] == X)
					break;
			}
			
			if (b > EXPMAX)
				printf("NU\n");
			else
				printf("DA\n");
		}
	}
	
	return 0;
}
